package
{
	import flash.display.MovieClip;
	import flash.utils.getTimer;
	import flash.events.Event;
	
	/**
	 * ...
	 * @author Jason Reinsvold
	 */
	public class FrameRateStatus extends MovieClip
	{
		private var frameCount:int = 0;
		private var averageFPS:Number = 0;
		private var timeOffset:int = getTimer();
		private var elapsedTime:int = 0;

		private var myTotalFrames:int = 0;
		private var totalElapsedTime:int = 0;
		private var minFPS:Number = Number.MAX_VALUE;
		private var maxFPS:Number = 0;
		private var myFPS:Number = 0;
		private var INTERVAL_TIME:int = 1000; // best not to 
		private var msg:String = "";

		public static var main:FrameRateStatus;
		
		public function FrameRateStatus()
		{
			main = this;
			startMonitor();
			this.stop();
		}
		
		public static function initialize():void
		{
			if (main == null) {
				new FrameRateStatus();
			}
		}

		private function step(event:Event):void
		{
			frameCount++;
			elapsedTime = (getTimer() - timeOffset);
			if (elapsedTime > INTERVAL_TIME) {
				updateFPS();
			}
		}

		private function updateFPS():void
		{
			myFPS = frameCount;

			if (myFPS > maxFPS) {
				maxFPS = myFPS;
			}
			if (myFPS < minFPS) {
				minFPS = myFPS;
			}
			
			myTotalFrames += frameCount;
			totalElapsedTime += elapsedTime;
			timeOffset = getTimer();
			
			averageFPS = Math.round(myTotalFrames / totalElapsedTime * 10000)/10;
			
			frameCount = 0;
		}
		
		public function get fps():int
		{
			return myFPS;
		}
		
		public function get fpsAvg():int
		{
			return averageFPS;
		}
		
		public function get fpsMin():int
		{
			return minFPS;
		}
		
		public function get fpsMax():int
		{
			return maxFPS;
		}
		
		public function get report():String
		{
			return "fps: " + myFPS + "\navg: " + averageFPS + "\nmin: " + minFPS + "\nmax: " + maxFPS + "\n";
		}
		
		public static function getReport():String
		{
			var report:String;
			
			if (main) {
				report = main.report;
			}
			else {
				report = "No framerate status.";
			}
			return report;
		}

		private function stopMonitor():void
		{
			this.removeEventListener(Event.ENTER_FRAME, step);
		}

		private function startMonitor():void
		{
			frameCount = 0;
			averageFPS = 0;
			timeOffset = getTimer();
			elapsedTime = 0;
			
			myTotalFrames = 0;
			totalElapsedTime = 0;
			minFPS = Number.MAX_VALUE;
			maxFPS = 0;
			myFPS = 0;
			INTERVAL_TIME = 1000; // best not to 
			msg = "";
			this.addEventListener(Event.ENTER_FRAME, step);
		}
		
		public function destroy():void
		{
			removeEventListener(Event.ENTER_FRAME, step);
			main = null;
		}
		
		public static function destroy():void
		{
			main.destroy();
			//trace("main: " + main);
		}
	}
	
}